module DetailedTimeEntries
	module Patches
		module TimeEntry
			unloadable
			
			def self.included(base)
				base.extend(ClassMethods)
				base.send(:include, InstanceMethods)
				base.class_eval do
					safe_attributes 'hours', 'comments', 'issue_id', 'activity_id', 'spent_on', 'custom_field_values', 'custom_fields', 'endtime'

					validate :validate_endtime

				end
			end

			module InstanceMethods
				def toTRaw
					if endtime.nil?
						return Time.now
					else
						return Time.parse(endtime) if endtime.kind_of? String
					end

					return endtime
				end

				def toT
					return toTRaw.change(year: spent_on.year, month: spent_on.month, day: spent_on.day)
				end

				def to
					return toT.strftime("%Y-%m-%dT%H:%M:%S.000%z")
				end

				def to_time
					return toT.strftime("%H:%M:%S")
				end

				def fromT
					return toT - hours.hours
				end

				def from
					return fromT.strftime("%Y-%m-%dT%H:%M:%S.000%z")
				end

				def from_time
					return fromT.strftime("%H:%M:%S")
				end

				def validate_endtime
				end
			end

			module ClassMethods
			end
		end
	end
end

TimeEntry.send(:include,  DetailedTimeEntries::Patches::TimeEntry)

